/****************************************************************************************  
**  This is example LINX firmware for use with the chipKIT WF32 with the serial 
**  interface enabled.
**
**  For more information see:           www.labviewmakerhub.com/linx
**  For support visit the forums at:    www.labviewmakerhub.com/forums/linx
**  
**  Written By Sam Kristoff and Sudharsan Sukumar
**
**  BSD2 License.
****************************************************************************************/

//Include All Peripheral Libraries Used By LINX
#include <SPI.h>
#include <Wire.h>
#include <EEPROM.h>
#include <Servo.h>
#include <WS2812.h>


//Include Device Specific Header From Sketch>>Import Library (In This Case LinxChipkitMax32.h)
//Also Include Desired LINX Listener From Sketch>>Import Library (In This Case LinxSerialListener.h)
#include <LinxChipkitWf32.h>
#include <LinxSerialListener.h>
 
//Create A Pointer To The LINX Device Object We Instantiate In Setup()
LinxChipkitWf32* LinxDevice;



int numENC = 3;
int encPinA[3];
int encPinB[3];
int lastModeA[3];
int lastModeB[3];
int curModeA[3];
int curModeB[3];
int encPos[3];
int encPosLast[3];
int change = 0;
int x=0;
int y[3]={};
int momentum=0;
int a=57;
int b=51;
int c=0;
int d=0;
int delaytime=50;
int ENC();
int swt[3];
int swtval[3];
int swtvallast[3];
int kswtval=HIGH;


//Initialize LINX Device And Listener
void setup()
{
  LinxDevice = new LinxChipkitWf32();

pinMode(PIN_INT0, INPUT);
pinMode(PIN_INT1, INPUT); 
pinMode(PIN_INT2, INPUT); 
pinMode(PIN_INT3, INPUT);

attachInterrupt(0, interruptkswt, FALLING);
attachInterrupt(1, interruptbut1, RISING);
attachInterrupt(2, interruptbut2, RISING);
attachInterrupt(3, interruptbut3, RISING);  

  //The LINXT Listener Is Pre Instantiated, Call Start And Pass A Pointer To The LINX Device And The UART Channel To Listen On
  LinxSerialConnection.Start(LinxDevice, 0);
  LinxSerialConnection.AttachCustomCommand(0, ENC);

    for (c=0;c<numENC;c++) 
    {
    pinMode(encPinA[c], INPUT);
    pinMode(encPinB[c], INPUT);
    lastModeA[c] = HIGH;
    lastModeB[c] = HIGH;
    curModeA[c] = HIGH;
    curModeB[c] = HIGH;
    encPos[c] = 0;
    encPosLast[c] = 0;
    }

}

void loop()
{ 
  

  //Listen For New Packets From LabVIEW
  LinxSerialConnection.CheckForCommands();
  
  

}

int ENC(unsigned char numInputBytes, unsigned char* input, unsigned char* numResponseBytes, unsigned char* response)
{

numENC=input[0];
delaytime = input[1];
momentum=input[2];


for(c=0;c<numENC;c++)
{
encPinA[c] = input[3+(5*c)];
encPinB[c] = input[4+(5*c)];
y[c] = input[5+(5*c)];
swtval[c]=input[6+(5*c)];
swt[c]=input[7+(5*c)];

if(y[c]<(54-momentum)||y[c]>(54+momentum))
{
  y[c]=54;
}
}

a=54+momentum;
b=54-momentum;

while(x!=1)
{ 
for (c=0;c<numENC&&x!=1;c++)  
{
change = 0;
curModeA[c] = digitalRead(encPinA[c]);
curModeB[c] = digitalRead(encPinB[c]);
swtval[c] = digitalRead(swt[c]);
kswtval = digitalRead(PIN_INT0);

if(kswtval==LOW)
{
  change=-1;
}
else if(swtval[c]!=swtvallast[c])
 {
  if(swtval[c]==HIGH)
  {
    d=0;
  }
  else if(swtval[c]==LOW)
  {
    d=1;
  }
 change=2; 
 }
 else if(curModeA[c]==LOW || curModeB[c]==LOW)
    {
     if (curModeA[c] != lastModeA[c]) 
    {
      ////////////////
      if (curModeA[c] == LOW) 
      {
        if (curModeB[c] == LOW)
        {
          if(y[c]>=54)
          {
         encPos[c]=2;
          }
           if(y[c]<a)
          {
            y[c]++;
          }
        } 
      } 
      
      else
      {
        if (curModeB[c] == LOW)
        {
          
           if(y[c]<=54)
          {
          encPos[c]=1;
          }
           if(y[c]>b)
          {
            y[c]--;
          }
        } 
      }
    } 
    //////////////////
   else if (curModeB[c] != lastModeB[c]) 
    {
      if (curModeB[c] == LOW) 
      {
        if (curModeA[c] == LOW) 
        {
          if(y[c]<=54)
          {
          encPos[c]=1;
          }
           if(y[c]>b)
          {
            y[c]--;
          }
        } 
      }
      else 
      {
        if (curModeA[c] == LOW)
        {
          if(y[c]>=54)
          {
         encPos[c]=2;
          }
           if(y[c]<a)
          {
            y[c]++;
          }
        }
      }
    }
    }
    else 
    {
      encPos[c]=0;
    }
    lastModeA[c]=curModeA[c];
    lastModeB[c]=curModeB[c];
 
     if (encPos[c] != encPosLast[c] && change != -1)
    {
      change = 1;
    }

if(change==0)
  {
    x=0;
  }
 else if(change==-1)
  {
    response[0]=c;
    response[1]=3;
    x=1;
    swtvallast[c]=swtval[c];
  }
  else if (change==-2)
  {
     response[0]=c;
    response[1]=4;
    x=1;
  }
    else if (change==-3)
  {
     response[0]=c;
    response[1]=5;
    x=1;
  }
    else if (change==-4)
  {
    response[0]=c;
    response[1]=6;
    x=1;
  }
  else if (change == 2)
  {
    response[0]=c;
    response[1]=7+((3*d)+c);
    x=1;
    swtvallast[c]=swtval[c];
  }
  
  else if (change == 1)
  {
    encPosLast[c]= encPos[c];
    response[0]= c;
    response[1]= encPos[c];
    delay(delaytime);
    x=1;
  }


}//for

}//while


for (c=0;c<numENC;c++)
{
response[2+(2*c)]=y[c];
response[3+(2*c)]=swtvallast[c]; 
}
*numResponseBytes = 2+2*numENC; 
x=0;
return 0;
}

void interruptkswt()
{
   change=-1;
}
void interruptbut1()
{
  change=-2;
}
void interruptbut2()
{
   change=-3;
}
void interruptbut3()
{  
  change=-4;
}



